install.sh 9.6 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247
  1. #!/bin/bash
  2. red='\033[0;31m'
  3. green='\033[0;32m'
  4. yellow='\033[0;33m'
  5. plain='\033[0m'
  6. cur_dir=$(pwd)
  7. # check root
  8. [[ $EUID -ne 0 ]] && echo -e "${red}Fatal error: ${plain} Please run this script with root privilege \n " && exit 1
  9. # Check OS and set release variable
  10. if [[ -f /etc/os-release ]]; then
  11. source /etc/os-release
  12. release=$ID
  13. elif [[ -f /usr/lib/os-release ]]; then
  14. source /usr/lib/os-release
  15. release=$ID
  16. else
  17. echo "Failed to check the system OS, please contact the author!" >&2
  18. exit 1
  19. fi
  20. echo "The OS release is: $release"
  21. arch() {
  22. case "$(uname -m)" in
  23. x86_64 | x64 | amd64) echo 'amd64' ;;
  24. i*86 | x86) echo '386' ;;
  25. armv8* | armv8 | arm64 | aarch64) echo 'arm64' ;;
  26. armv7* | armv7 | arm) echo 'armv7' ;;
  27. armv6* | armv6) echo 'armv6' ;;
  28. armv5* | armv5) echo 'armv5' ;;
  29. s390x) echo 's390x' ;;
  30. *) echo -e "${green}Unsupported CPU architecture! ${plain}" && rm -f install.sh && exit 1 ;;
  31. esac
  32. }
  33. echo "arch: $(arch)"
  34. os_version=""
  35. os_version=$(grep -i version_id /etc/os-release | cut -d \" -f2 | cut -d . -f1)
  36. if [[ "${release}" == "arch" ]]; then
  37. echo "Your OS is Arch Linux"
  38. elif [[ "${release}" == "parch" ]]; then
  39. echo "Your OS is Parch linux"
  40. elif [[ "${release}" == "manjaro" ]]; then
  41. echo "Your OS is Manjaro"
  42. elif [[ "${release}" == "armbian" ]]; then
  43. echo "Your OS is Armbian"
  44. elif [[ "${release}" == "opensuse-tumbleweed" ]]; then
  45. echo "Your OS is OpenSUSE Tumbleweed"
  46. elif [[ "${release}" == "centos" ]]; then
  47. if [[ ${os_version} -lt 8 ]]; then
  48. echo -e "${red} Please use CentOS 8 or higher ${plain}\n" && exit 1
  49. fi
  50. elif [[ "${release}" == "ubuntu" ]]; then
  51. if [[ ${os_version} -lt 20 ]]; then
  52. echo -e "${red} Please use Ubuntu 20 or higher version!${plain}\n" && exit 1
  53. fi
  54. elif [[ "${release}" == "fedora" ]]; then
  55. if [[ ${os_version} -lt 36 ]]; then
  56. echo -e "${red} Please use Fedora 36 or higher version!${plain}\n" && exit 1
  57. fi
  58. elif [[ "${release}" == "debian" ]]; then
  59. if [[ ${os_version} -lt 11 ]]; then
  60. echo -e "${red} Please use Debian 11 or higher ${plain}\n" && exit 1
  61. fi
  62. elif [[ "${release}" == "almalinux" ]]; then
  63. if [[ ${os_version} -lt 9 ]]; then
  64. echo -e "${red} Please use AlmaLinux 9 or higher ${plain}\n" && exit 1
  65. fi
  66. elif [[ "${release}" == "rocky" ]]; then
  67. if [[ ${os_version} -lt 9 ]]; then
  68. echo -e "${red} Please use Rocky Linux 9 or higher ${plain}\n" && exit 1
  69. fi
  70. elif [[ "${release}" == "oracle" ]]; then
  71. if [[ ${os_version} -lt 8 ]]; then
  72. echo -e "${red} Please use Oracle Linux 8 or higher ${plain}\n" && exit 1
  73. fi
  74. else
  75. echo -e "${red}Your operating system is not supported by this script.${plain}\n"
  76. echo "Please ensure you are using one of the following supported operating systems:"
  77. echo "- Ubuntu 20.04+"
  78. echo "- Debian 11+"
  79. echo "- CentOS 8+"
  80. echo "- Fedora 36+"
  81. echo "- Arch Linux"
  82. echo "- Parch Linux"
  83. echo "- Manjaro"
  84. echo "- Armbian"
  85. echo "- AlmaLinux 9+"
  86. echo "- Rocky Linux 9+"
  87. echo "- Oracle Linux 8+"
  88. echo "- OpenSUSE Tumbleweed"
  89. exit 1
  90. fi
  91. install_base() {
  92. case "${release}" in
  93. ubuntu | debian | armbian)
  94. apt-get update && apt-get install -y -q wget curl tar tzdata
  95. ;;
  96. centos | almalinux | rocky | oracle)
  97. yum -y update && yum install -y -q wget curl tar tzdata
  98. ;;
  99. fedora)
  100. dnf -y update && dnf install -y -q wget curl tar tzdata
  101. ;;
  102. arch | manjaro | parch)
  103. pacman -Syu && pacman -Syu --noconfirm wget curl tar tzdata
  104. ;;
  105. opensuse-tumbleweed)
  106. zypper refresh && zypper -q install -y wget curl tar timezone
  107. ;;
  108. *)
  109. apt-get update && apt install -y -q wget curl tar tzdata
  110. ;;
  111. esac
  112. }
  113. gen_random_string() {
  114. local length="$1"
  115. local random_string=$(LC_ALL=C tr -dc 'a-zA-Z0-9' </dev/urandom | fold -w "$length" | head -n 1)
  116. echo "$random_string"
  117. }
  118. # This function will be called when user installed x-ui out of security
  119. config_after_install() {
  120. echo -e "${yellow}Install/update finished! For security it's recommended to modify panel settings ${plain}"
  121. read -p "Would you like to customize the panel settings? (If not, random settings will be applied) [y/n]: " config_confirm
  122. if [[ "${config_confirm}" == "y" || "${config_confirm}" == "Y" ]]; then
  123. read -p "Please set up your username: " config_account
  124. echo -e "${yellow}Your username will be: ${config_account}${plain}"
  125. read -p "Please set up your password: " config_password
  126. echo -e "${yellow}Your password will be: ${config_password}${plain}"
  127. read -p "Please set up the panel port: " config_port
  128. echo -e "${yellow}Your panel port is: ${config_port}${plain}"
  129. read -p "Please set up the web base path (ip:port/webbasepath/): " config_webBasePath
  130. echo -e "${yellow}Your web base path is: ${config_webBasePath}${plain}"
  131. echo -e "${yellow}Initializing, please wait...${plain}"
  132. /usr/local/x-ui/x-ui setting -username ${config_account} -password ${config_password}
  133. echo -e "${yellow}Account name and password set successfully!${plain}"
  134. /usr/local/x-ui/x-ui setting -port ${config_port}
  135. echo -e "${yellow}Panel port set successfully!${plain}"
  136. /usr/local/x-ui/x-ui setting -webBasePath ${config_webBasePath}
  137. echo -e "${yellow}Web base path set successfully!${plain}"
  138. else
  139. echo -e "${red}Cancel...${plain}"
  140. if [[ ! -f "/etc/x-ui/x-ui.db" ]]; then
  141. local usernameTemp=$(head -c 6 /dev/urandom | base64)
  142. local passwordTemp=$(head -c 6 /dev/urandom | base64)
  143. local webBasePathTemp=$(gen_random_string 10)
  144. /usr/local/x-ui/x-ui setting -username ${usernameTemp} -password ${passwordTemp} -webBasePath ${webBasePathTemp}
  145. echo -e "This is a fresh installation, will generate random login info for security concerns:"
  146. echo -e "###############################################"
  147. echo -e "${green}Username: ${usernameTemp}${plain}"
  148. echo -e "${green}Password: ${passwordTemp}${plain}"
  149. echo -e "${green}WebBasePath: ${webBasePathTemp}${plain}"
  150. echo -e "###############################################"
  151. echo -e "${yellow}If you forgot your login info, you can type "x-ui settings" to check after installation${plain}"
  152. else
  153. echo -e "${yellow}This is your upgrade, will keep old settings. If you forgot your login info, you can type "x-ui settings" to check${plain}"
  154. fi
  155. fi
  156. /usr/local/x-ui/x-ui migrate
  157. }
  158. install_x-ui() {
  159. cd /usr/local/
  160. if [ $# == 0 ]; then
  161. last_version=$(curl -Ls "https://api.github.com/repos/MHSanaei/3x-ui/releases/latest" | grep '"tag_name":' | sed -E 's/.*"([^"]+)".*/\1/')
  162. if [[ ! -n "$last_version" ]]; then
  163. echo -e "${red}Failed to fetch x-ui version, it maybe due to Github API restrictions, please try it later${plain}"
  164. exit 1
  165. fi
  166. echo -e "Got x-ui latest version: ${last_version}, beginning the installation..."
  167. wget -N --no-check-certificate -O /usr/local/x-ui-linux-$(arch).tar.gz https://github.com/MHSanaei/3x-ui/releases/download/${last_version}/x-ui-linux-$(arch).tar.gz
  168. if [[ $? -ne 0 ]]; then
  169. echo -e "${red}Downloading x-ui failed, please be sure that your server can access Github ${plain}"
  170. exit 1
  171. fi
  172. else
  173. last_version=$1
  174. url="https://github.com/MHSanaei/3x-ui/releases/download/${last_version}/x-ui-linux-$(arch).tar.gz"
  175. echo -e "Beginning to install x-ui $1"
  176. wget -N --no-check-certificate -O /usr/local/x-ui-linux-$(arch).tar.gz ${url}
  177. if [[ $? -ne 0 ]]; then
  178. echo -e "${red}Download x-ui $1 failed,please check the version exists ${plain}"
  179. exit 1
  180. fi
  181. fi
  182. if [[ -e /usr/local/x-ui/ ]]; then
  183. systemctl stop x-ui
  184. rm /usr/local/x-ui/ -rf
  185. fi
  186. tar zxvf x-ui-linux-$(arch).tar.gz
  187. rm x-ui-linux-$(arch).tar.gz -f
  188. cd x-ui
  189. chmod +x x-ui
  190. # Check the system's architecture and rename the file accordingly
  191. if [[ $(arch) == "armv5" || $(arch) == "armv6" || $(arch) == "armv7" ]]; then
  192. mv bin/xray-linux-$(arch) bin/xray-linux-arm
  193. chmod +x bin/xray-linux-arm
  194. fi
  195. chmod +x x-ui bin/xray-linux-$(arch)
  196. cp -f x-ui.service /etc/systemd/system/
  197. wget --no-check-certificate -O /usr/bin/x-ui https://raw.githubusercontent.com/MHSanaei/3x-ui/main/x-ui.sh
  198. chmod +x /usr/local/x-ui/x-ui.sh
  199. chmod +x /usr/bin/x-ui
  200. config_after_install
  201. systemctl daemon-reload
  202. systemctl enable x-ui
  203. systemctl start x-ui
  204. echo -e "${green}x-ui ${last_version}${plain} installation finished, it is running now..."
  205. echo -e ""
  206. echo -e "x-ui control menu usages: "
  207. echo -e "----------------------------------------------"
  208. echo -e "SUBCOMMANDS:"
  209. echo -e "x-ui - Admin Management Script"
  210. echo -e "x-ui start - Start"
  211. echo -e "x-ui stop - Stop"
  212. echo -e "x-ui restart - Restart"
  213. echo -e "x-ui status - Current Status"
  214. echo -e "x-ui settings - Current Settings"
  215. echo -e "x-ui enable - Enable Autostart on OS Startup"
  216. echo -e "x-ui disable - Disable Autostart on OS Startup"
  217. echo -e "x-ui log - Check logs"
  218. echo -e "x-ui banlog - Check Fail2ban ban logs"
  219. echo -e "x-ui update - Update"
  220. echo -e "x-ui custom - custom version"
  221. echo -e "x-ui install - Install"
  222. echo -e "x-ui uninstall - Uninstall"
  223. echo -e "----------------------------------------------"
  224. }
  225. echo -e "${green}Running...${plain}"
  226. install_base
  227. install_x-ui $1